
USE AdventureWorks2012; 
GO


--> Attenzione: circa 50 secondi per 31.465 righe!!!
SET STATISTICS IO ON; 
SELECT
	   ( 
		  SELECT COUNT( * )
		  FROM Sales.SalesOrderHeader AS O2
		  WHERE O2.SalesOrderID <= O1.SalesOrderID 
	   ) AS rownum , 
      SalesOrderID , 
      CONVERT( varchar( 10 ) , orderdate , 120 ) AS orderdate , 
      customerid
  FROM Sales.SalesOrderHeader AS O1
  ORDER BY SalesOrderID;




SELECT ROW_NUMBER( ) OVER( ORDER BY SalesOrderID )AS rownum , 
       SalesOrderID , 
       CONVERT( varchar( 10 ) , orderdate , 120 )AS orderdate , 
       customerid
  FROM Sales.SalesOrderHeader AS O1
  ORDER BY SalesOrderID;




/*
Senza ROW_NUMBER: 
Table 'Worktable'. Scan count 31465, logical reads 1174675
Table 'SalesOrderHeader'. Scan count 2, logical reads 746

Con ROW_NUMBER: 
Table 'SalesOrderHeader'. Scan count 1, logical reads 689
*/


/* La clausola OVER posso "tagliarla" o no, a seconda delle mie esigenze */
--> senza PARTITION BY
SELECT ROW_NUMBER() OVER ( ORDER BY BirthDate) AS RowNumber,  
LoginID, BirthDate, MaritalStatus, Gender, OrganizationLevel 
FROM [HumanResources].[Employee] 


--> con PARTITION BY
SELECT ROW_NUMBER() OVER ( PARTITION BY OrganizationLevel ORDER BY BirthDate) AS RowNumber,  
LoginID, BirthDate, MaritalStatus, Gender, OrganizationLevel 
FROM [HumanResources].[Employee]
