

USE AdventureWorks2012 
GO

SELECT TOP 5 Name, ProductSubCategoryID, ListPrice 
  FROM Production.Product WHERE ProductSubCategoryID IS NOT NULL;


/* 1. calcolo la media per ogni sottocategoria */
SELECT 
    P2.ProductSubCategoryID,
    AVG(P2.ListPrice) AS AveragePrice
FROM Production.Product P2
WHERE 
    P2.ProductSubCategoryID IS NOT NULL
GROUP BY 
    P2.ProductSubCategoryID


/* 2. metto in join il mio calcolo con i prodotti */
SET STATISTICS IO ON
SELECT
	P.Name AS ProductName,
	P.ListPrice,
	PS.Name AS ProductSubCategoryName,
	x.AveragePrice
FROM Production.Product P
JOIN Production.ProductSubCategory PS ON P.ProductSubCategoryID = PS.ProductSubCategoryID
JOIN
(
	SELECT 
		P2.ProductSubCategoryID,
		AVG(P2.ListPrice) AS AveragePrice
	FROM Production.Product P2
	WHERE 
		P2.ProductSubCategoryID IS NOT NULL
	GROUP BY 
		P2.ProductSubCategoryID
) x ON x.ProductSubCategoryID = P.ProductSubCategoryId
ORDER BY 
	P.Name





SELECT
	P.Name AS ProductName,
	P.ListPrice,
	PS.Name AS ProductSubCategoryName,
	AVG(P.ListPrice) OVER (PARTITION BY P.ProductSubCategoryID)
FROM Production.Product P
JOIN Production.ProductSubCategory PS ON P.ProductSubCategoryID = PS.ProductSubCategoryID
ORDER BY 
	P.Name



/*
Senza OVER:
    Table 'Product'. Scan count 2, logical reads 32
    Table 'ProductSubcategory'. Scan count 0, logical reads 74

Con OVER:
    Table 'Product'. Scan count 1, logical reads 16
    Table 'ProductSubcategory'. Scan count 1, logical reads 2
*/