
USE CDays; 
GO

SET STATISTICS IO ON
DECLARE @StartDate datetime , 
        @EndDate datetime;
SET @StartDate = GETDATE( );  

    SELECT customerID , 
		 qty , 
		 qty + ISNULL( LAG( qty )
		    OVER( PARTITION BY customerID ORDER BY idRecord ) , 0 )AS qtySum
	 FROM orders
	 ORDER BY customerID , idRecord;

SET @EndDate = GETDATE( );
SELECT DATEDIFF( ms , @StartDate , @EndDate )
    AS 'Execution time in ms';


/* ********************************************************* */
/*
posso specificare un OFFSET ed un DEFAULT:

LAG(EmployeeTotal, 1, 0.00)
LAG(EmployeeTotal, 3, 0.00)
*/

Use [AdventureWorksDW2012] 
go

; with CteEmployeeSalesByMonth
as
(
SELECT  EmployeeKey as [Employee],
         DATEPART(yyyy, CAST(CAST(OrderDateKey as varchar(8)) as DATE)) AS [Year] ,
         DATEPART(mm, CAST(CAST(OrderDateKey as varchar(8)) as DATE)) AS [Month] ,
         SUM(SalesAmount) AS [EmployeeTotal]
 FROM    dbo.FactResellerSales
 WHERE    EmployeeKey IS NOT NULL
 GROUP BY EmployeeKey,
         DATEPART(yyyy, CAST(CAST(OrderDateKey as varchar(8)) as DATE)),
         DATEPART(mm, CAST(CAST(OrderDateKey as varchar(8)) as DATE))
)

SELECT  Employee,
         [Year] ,
         [Month] ,
         EmployeeTotal AS SalesThisMonth,
         LAG(EmployeeTotal, 1, 0.00) OVER (PARTITION BY Employee ORDER BY [Year], [Month]) AS SalesLastMonth ,
         LAG(EmployeeTotal, 3, 0.00) OVER (PARTITION BY Employee ORDER BY [Year], [Month]) AS SalesThreeMonthsAgo
 FROM CteEmployeeSalesByMonth
 WHERE Employee = 272
 ORDER BY Employee, [Year], [Month];
GO

/* ********************************************************* */

USE tempdb;
GO

CREATE TABLE MonthlyProfit
(
    yearid int,
    Monthid int,
    Profit bigint
)
GO

INSERT INTO MonthlyProfit (yearid, Monthid, Profit)
VALUES
(2012,1,1766), (2012,2,100), (2012,3,1500), (2012,4,15000), (2012,5,900), (2012,6,45),
(2012,7,1766), (2012,8,9100), (2012,9,-100), (2012,10,50), (2012,11,900000), (2012,12,6575)
go

SELECT *
  FROM MonthlyProfit; 
GO
/*
Ho 12 righe.

Quante "logical reads" potrei avere calcolando il running totals? 
Che piano di esecuzione mi aspetto?
*/

SET STATISTICS IO ON
SELECT
 t1.yearid,
 t1.Monthid,
 t1.Profit as ProfitThisMonth,
 t2.Profit as ProfitLastMonth
FROM MonthlyProfit as t1
LEFT JOIN MonthlyProfit as t2 on (t1.yearid = t2.yearid) AND (t1.Monthid = t2.Monthid+1)


SELECT
 yearid,
 monthid,
 Profit as ProfitThisMonth,
 LAG(Profit, 1, 0) OVER(Order by yearid, monthid) as ProfitLastMonth
FROM MonthlyProfit
GO


/* aggiungo un anno (12 mesi) */
INSERT INTO MonthlyProfit
SELECT 2013 , 
       monthid , 
       profit
  FROM MonthlyProfit;



SELECT
 t1.yearid,
 t1.Monthid,
 t1.Profit as ProfitThisMonth,
 t2.Profit as ProfitLastMonth
FROM MonthlyProfit as t1
LEFT JOIN MonthlyProfit as t2 on (t1.yearid = t2.yearid) AND (t1.Monthid = t2.Monthid+1)


SELECT
 yearid,
 monthid,
 Profit as ProfitThisMonth,
 LAG(Profit, 1, 0) OVER(Order by yearid, monthid) as ProfitLastMonth
FROM MonthlyProfit
GO


DROP TABLE MonthlyProfit
GO
