
USE CDays; 
GO


/*
-- iscritti YoY
SELECT idConference AS Anno , 
       COUNT( 1 )AS Iscritti
  FROM Sheet1
  WHERE idconference IS NOT NULL
  GROUP BY idconference;
*/

/*
SELECT TOP 5 *
  FROM Sheet1; 
*/

SET STATISTICS IO ON
;with cteUserData as
(
    select 
	   count(1) as Num,
	   year(registrationDate) as RegistrationYear,
	   month(registrationDate) as RegistrationMonth,
	   idConference
    from Sheet1 
    where idConference is not null    
    group by idConference, month(registrationDate), year(registrationDate)
    
),
cteRegistration as
(
    select Num, idConference as Conference, 
    cast( cast(RegistrationYear as varchar(4)) + '-' + 
	   cast(RegistrationMonth as varchar(2)) + '-01'  as date) as RegistrationDate
    from cteUserData 
)


SELECT AC.Num AS [Num Anno Corrente] , 
       AP.Num AS [Num Anno Precedente] , 
       AC.RegistrationDate , 
       AC.Conference
  FROM cteRegistration AC 
LEFT JOIN cteRegistration AP ON DATEADD( YEAR , -1 , AC.RegistrationDate ) = AP.RegistrationDate
  ORDER BY AC.RegistrationDate; 

--SELECT Num AS [Num Anno Corrente] , 
--       LAG( Num , 1 , NULL ) OVER ( PARTITION BY MONTH( RegistrationDate ) 
--					   ORDER BY RegistrationDate )AS [Num Anno Precedente] , 
--       RegistrationDate , 
--       Conference
--  FROM cteRegistration
--  ORDER BY RegistrationDate; 





--> [SQL 2012] Table 'Sheet1'. Scan count 1, logical reads 86
--> [SQL 2008] Table 'Sheet1'. Scan count 10, logical reads 172


-- anno 2013 YoY w.%
SET STATISTICS IO ON;
WITH cteNum AS 
( 
    SELECT Num AS [Num Anno Corrente] , 
                LAG( Num , 1 , 0 )	 OVER    ( PARTITION BY MONTH( RegistrationDate )
				    ORDER BY RegistrationDate )AS [Num Anno Precedente] , 
                RegistrationDate , 
                Conference
           FROM Registration 
)
SELECT RegistrationDate , 
        [Num Anno Corrente] , 
        [Num Anno Precedente] , 
        CAST( CAST((CAST( [Num Anno Corrente] AS decimal( 20 , 4 )) - 
		  CAST( [Num Anno Precedente] AS decimal( 20 , 4 ))) / CASE
			 WHEN [Num Anno Precedente] = 0 THEN 1
				ELSE [Num Anno Precedente]
			 END * 100 AS decimal( 20 , 2 ))AS varchar( 20 )) + ' %' AS [%]
    FROM cteNum
    WHERE conference = 2013
    ORDER BY RegistrationDate; 

